<?php
/**
 * GroupBrands
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  DocuSign\eSign
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DocuSign REST API
 *
 * The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.
 *
 * OpenAPI spec version: v2.1
 * Contact: devcenter@docusign.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.21-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace DocuSign\eSign\Model;

use \ArrayAccess;
use DocuSign\eSign\ObjectSerializer;

/**
 * GroupBrands Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     DocuSign\eSign
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GroupBrands implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'GroupBrands';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'recipient_brand_id_default' => '?string',
        'sender_brand_id_default' => '?string',
        'brand_options' => '\DocuSign\eSign\Model\Brand[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'recipient_brand_id_default' => null,
        'sender_brand_id_default' => null,
        'brand_options' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'recipient_brand_id_default' => 'recipientBrandIdDefault',
        'sender_brand_id_default' => 'senderBrandIdDefault',
        'brand_options' => 'brandOptions'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'recipient_brand_id_default' => 'setRecipientBrandIdDefault',
        'sender_brand_id_default' => 'setSenderBrandIdDefault',
        'brand_options' => 'setBrandOptions'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'recipient_brand_id_default' => 'getRecipientBrandIdDefault',
        'sender_brand_id_default' => 'getSenderBrandIdDefault',
        'brand_options' => 'getBrandOptions'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['recipient_brand_id_default'] = isset($data['recipient_brand_id_default']) ? $data['recipient_brand_id_default'] : null;
        $this->container['sender_brand_id_default'] = isset($data['sender_brand_id_default']) ? $data['sender_brand_id_default'] : null;
        $this->container['brand_options'] = isset($data['brand_options']) ? $data['brand_options'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets recipient_brand_id_default
     *
     * @return ?string
     */
    public function getRecipientBrandIdDefault()
    {
        return $this->container['recipient_brand_id_default'];
    }

    /**
     * Sets recipient_brand_id_default
     *
     * @param ?string $recipient_brand_id_default The brand seen by envelope recipients when a brand is not explicitly set.
     *
     * @return $this
     */
    public function setRecipientBrandIdDefault($recipient_brand_id_default)
    {
        $this->container['recipient_brand_id_default'] = $recipient_brand_id_default;

        return $this;
    }

    /**
     * Gets sender_brand_id_default
     *
     * @return ?string
     */
    public function getSenderBrandIdDefault()
    {
        return $this->container['sender_brand_id_default'];
    }

    /**
     * Sets sender_brand_id_default
     *
     * @param ?string $sender_brand_id_default The brand seen by envelope senders when a brand is not explicitly set.
     *
     * @return $this
     */
    public function setSenderBrandIdDefault($sender_brand_id_default)
    {
        $this->container['sender_brand_id_default'] = $sender_brand_id_default;

        return $this;
    }

    /**
     * Gets brand_options
     *
     * @return \DocuSign\eSign\Model\Brand[]
     */
    public function getBrandOptions()
    {
        return $this->container['brand_options'];
    }

    /**
     * Sets brand_options
     *
     * @param \DocuSign\eSign\Model\Brand[] $brand_options The list of brands.
     *
     * @return $this
     */
    public function setBrandOptions($brand_options)
    {
        $this->container['brand_options'] = $brand_options;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}

